"use strict";
(self["webpackChunk_educational_technology_collective_etc_jupyterlab_cell_properties"] = self["webpackChunk_educational_technology_collective_etc_jupyterlab_cell_properties"] || []).push([["lib_index_js"],{

/***/ "./lib/index.js":
/*!**********************!*\
  !*** ./lib/index.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_settingregistry__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/settingregistry */ "webpack/sharing/consume/default/@jupyterlab/settingregistry");
/* harmony import */ var _jupyterlab_settingregistry__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_settingregistry__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/docmanager */ "webpack/sharing/consume/default/@jupyterlab/docmanager");
/* harmony import */ var _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_3__);




class CellWrapper {
    constructor({ cell }) {
        this.dispose = this.dispose.bind(this);
        this.onCellMetadataChanged = this.onCellMetadataChanged.bind(this);
        this.update = this.update.bind(this);
        this._cell = cell;
        cell.model.metadata.changed.connect(this.onCellMetadataChanged, this);
        cell.disposed.connect(this.dispose, this);
        setTimeout(this.update, 0);
    }
    dispose() {
        _lumino_signaling__WEBPACK_IMPORTED_MODULE_3__.Signal.disconnectAll(this);
    }
    update() {
        var _a, _b;
        if ((_b = (_a = this._cell) === null || _a === void 0 ? void 0 : _a.model) === null || _b === void 0 ? void 0 : _b.metadata.has(PLUGIN_ID)) {
            let metadata = this._cell.model.metadata.get(PLUGIN_ID);
            if (metadata["style"] !== null && typeof metadata["style"] == "object") {
                Object.assign(this._cell.node.style, metadata["style"]);
            }
        }
    }
    onCellMetadataChanged(sender, args) {
        if (args.key == PLUGIN_ID) {
            let style = args.newValue["style"];
            if (style !== null && typeof style == "object") {
                Object.assign(this._cell.node.style, style);
            }
        }
    }
}
const PLUGIN_ID = "@educational-technology-collective/etc_jupyterlab_cell_properties:plugin";
/**
 * Initialization data for the @educational-technology-collective/etc_jupyterlab_cell_properties extension.
 */
const plugin = {
    id: PLUGIN_ID,
    autoStart: true,
    optional: [_jupyterlab_settingregistry__WEBPACK_IMPORTED_MODULE_1__.ISettingRegistry],
    requires: [
        _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__.INotebookTracker,
        _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_2__.IDocumentManager
    ],
    activate: (app, notebookTracker, documentManager, settingRegistry) => {
        console.log('JupyterLab extension @educational-technology-collective/etc_jupyterlab_cell_properties is activated!');
        notebookTracker.widgetAdded.connect(async (sender, notebookPanel) => {
            var _a;
            await notebookPanel.revealed;
            notebookPanel.content.widgets.forEach((cell) => {
                new CellWrapper({ cell });
            });
            (_a = notebookPanel.content.model) === null || _a === void 0 ? void 0 : _a.cells.changed.connect((sender, args) => {
                if (args.type == "add" || args.type == "set") {
                    args.newValues.forEach((model) => {
                        let cell = notebookPanel.content.widgets.find((cell) => cell.model == model);
                        if (cell) {
                            new CellWrapper({ cell });
                        }
                    });
                }
                else {
                }
            });
        });
    }
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (plugin);


/***/ })

}]);
//# sourceMappingURL=lib_index_js.82cd5507e7f53d344b10.js.map